unit hiSpeech;

interface

uses Kol,Share,Debug,Speech,Windows,ActiveX;

type
  THISpeech = class(TDebug)
   private
    fITTSCentral: ITTSCentral;     { ,       }
    fIAMM: IAudioMultimediaDevice; {     }
    aTTSEnum: ITTSEnum;            {   }
    fpModeInfo: PTTSModeInfo;      {   }
    FList:PStrList;

    procedure Select(const Index:word);
   public
    _data_Text:THI_Event;
    _data_Select:THI_Event;
    _event_onEnum:THI_Event;
    _event_Error:THI_Event;

    constructor Create;
    procedure _work_doSpeech(var _Data:TData; Index:word);
    procedure _work_doEnum(var _Data:TData; Index:word);
    procedure _work_doSelect(var _Data:TData; Index:word);
  end;

implementation

constructor THISpeech.Create;
begin
  inherited;
  OleInit;
  CoCreateInstance(CLSID_MMAudioDest, Nil, CLSCTX_ALL, IID_IAudioMultiMediaDevice, fIAMM);
  CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
  Select(0);
end;

procedure THISpeech._work_doEnum;
var ModeInfo : TTSModeInfo;
    NumFound : DWord;
begin
  if aTTSEnum = nil then
   begin
    aTTSEnum.Reset;//  
    aTTSEnum.Next(1, ModeInfo, @NumFound); {  }
    FList := NewStrList;
    While NumFound > 0 do
     begin
       _hi_OnEvent(_event_onEnum,String(ModeInfo.szModeName));
       aTTSEnum.Next(1, ModeInfo, @NumFound); { }
     end;
   end
  else _hi_CreateEvent(_Data,@_event_Error);
end;

procedure THISpeech._work_doSelect;
begin
  if aTTSEnum = nil then
   Select(ReadInteger(_Data,_data_Select,0))
  else _hi_CreateEvent(_Data,@_event_Error);   
end;

procedure THISpeech.Select;
var
 NumFound: DWord;
 ModeInfo : TTSModeInfo;
begin
   CoCreateInstance(CLSID_MMAudioDest, Nil, CLSCTX_ALL, IID_IAudioMultiMediaDevice, fIAMM);
   CoCreateInstance(CLSID_TTSEnumerator, Nil, CLSCTX_ALL, IID_ITTSEnum, aTTSEnum);
  if aTTSEnum <> nil then
   begin
     aTTSEnum.Reset;
     aTTSEnum.skip(Index);
     aTTSEnum.Next(1, ModeInfo, @NumFound);
     if assigned(fpModeInfo) then
      dispose(fpModeInfo);
     new(fpModeInfo);
     fpModeInfo^ := ModeInfo;
     aTTSEnum.Select(fpModeInfo^.gModeID, fITTSCentral, IUnknown(fIAMM));
   end;
end;

procedure THISpeech._work_doSpeech;
var
  SData: TSData;
  BufRich: string;
begin
  if not Assigned(fITTSCentral) then
   begin
    ShowMessage(' !');
    exit;
   end;
  BufRich := ReadString(_Data,_data_Text,'');
  SData.dwSize := length(BufRich) + 1;
  SData.pData := pChar(BufRich);
  try
    fITTSCentral.TextData(CHARSET_TEXT, 0, SData, nil,IID_ITTSBufNotifySink);
  except
  end;
end;

end.
